package alphabet

import (
	"git.frostfs.info/TrueCloudLab/frostfs-node/internal/logs"
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/innerring/timers"
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/morph/event"
	"go.uber.org/zap"
)

func (ap *Processor) HandleGasEmission(ev event.Event) {
	_ = ev.(timers.NewAlphabetEmitTick)
	ap.log.Info(logs.AlphabetTick, zap.String("type", "alphabet gas emit"))

	// send event to the worker pool

	err := ap.pool.Submit(func() { ap.processEmit() })
	if err != nil {
		// there system can be moved into controlled degradation stage
		ap.log.Warn(logs.AlphabetAlphabetProcessorWorkerPoolDrained,
			zap.Int("capacity", ap.pool.Cap()))
	}
}
